/*  pnp05.cc : June 5, 1996  */

/* Copyright (C) 1996-1999  Sekhar Bala,
 *                          Ramchander Balasubramanian, and
 *                          Alphax Systems, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <unistd.h>

#include "std.h"
#include "pnp.h"


/*--------------------------------------------------------------------------*/


GLOBAL VOID udelay( long amt )
{
#ifndef __GO32__
 int                 ret;
 struct timespec     t;

    t.tv_sec  = 0;
    t.tv_nsec = (amt/2);
    ret       = nanosleep( &t, (struct timespec *) 0 );
    if ( ret < 0 )
       perror("nanosleep failed");
#else

    amt = amt/2;
    usleep( amt );

#endif
    return;

} /* udelay */


GLOBAL CHAR *binstring1( UCHAR val )
{
 STATIC CHAR   buf[10];
        INT_2  i;
        INT_2  j;

   for( i=0; (i < 8); i++ ) {
      j = 7 - i;
      if ( (val & 0x01) != 0 )
         buf[j] = '1';
      else
         buf[j] = '0';
      val >>= 1;
   }
   buf[8] = 'b';
   buf[9] = 0;
   return( buf );

} /* binstring1 */


GLOBAL CHAR *binstring2( INT_2 val )
{
 STATIC CHAR   buf[18];
        INT_2  i;
        INT_2  j;

   for( i=0; (i < 16); i++ ) {
      j = 15 - i;
      if ( (val & 0x01) != 0 )
         buf[j] = '1';
      else
         buf[j] = '0';
      val >>= 1;
   }
   buf[16] = 'b';
   buf[17] = 0;
   return( buf );

} /* binstring2 */


GLOBAL CHAR *binstring4( INT_4 val )
{
 STATIC CHAR   buf[34];
        INT_2  i;
        INT_2  j;

   for( i=0; (i < 32); i++ ) {
      j = 31 - i;
      if ( (val & 0x01) != 0 )
         buf[j] = '1';
      else
         buf[j] = '0';
      val >>= 1;
   }
   buf[32] = 'b';
   buf[33] = 0;
   return( buf );

} /* binstring4 */


/*--------------------------------------------------------------------------*/

